// FsUnpacker.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "class\CustomPack.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <conio.h>


bool initialize(char* exePath)
{
	HINSTANCE newInstanceHandle = GetModuleHandle(NULL);

	bool result = true;

	HKEY keyHandle;
	char value[MAX_PATH];
	LONG regResult;

	regResult = RegCreateKeyEx(HKEY_CLASSES_ROOT , ".fpk", 0, NULL,
	REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, 
	&keyHandle, NULL);


	if (regResult==ERROR_SUCCESS){
		
		ZeroMemory(value,sizeof(value));

		strcpy(value,"FileSystemPak");
		RegSetValueEx(keyHandle, NULL, 0, REG_SZ, 
				(BYTE*) value, 
				(strlen(value) + 1)
			);


		RegCloseKey(keyHandle);
	}

	regResult = RegCreateKeyEx(HKEY_CLASSES_ROOT , "FileSystemPak\\shell\\open\\command", 0, NULL,
	REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, 
	&keyHandle, NULL);


	if (regResult==ERROR_SUCCESS){
				
		ZeroMemory(value,sizeof(value));

		strcpy(value,"\"");
		strcat(value,exePath);
		strcat(value,"\" \"%1\"");

		RegSetValueEx(keyHandle, NULL, 0, REG_SZ, 
				(BYTE*) value, 
				(strlen(value) + 1)
			);


		RegCloseKey(keyHandle);


	}


	return result;
}


int main(int argc, char* argv[])
{
	initialize(argv[0]);


	printf ("Unpacker tool\n\n");

	if (argc < 2){
		
		printf ("FSUNPACKER pakfile [directory] \n\n");

		printf ("\tdirectory\n");
		printf ("\t\tdirectory to extract the files.\n");

		printf ("\tpakfile\n");
		printf ("\t\tinput pak file name.\n\n");

		printf ("Note : Youl could use the explorer to unpack pack files.\n");
		printf ("Select a .ypf file in My Computer or Explorer and dobule click over it.\n");
		printf ("This will stract the content of the file.");		
	}else{
		
		char directory[MAX_PATH];
		char fileName[MAX_PATH];

		ZeroMemory(directory,sizeof(directory));
		ZeroMemory(fileName,sizeof(fileName));



		strcpy(fileName,argv[1]);

		if (argc>2){

			strcpy(directory,argv[2]);		
		}else{
	
			strcpy(directory,fileName);
			char* p = strstr(directory,".");

			*p = 0;
			strcpy(directory,directory);
		}

		



		CResult result = resultOk;
		

		CCustomPack pack;

		result = pack.initialize(fileName);

		if (result==resultOk){
			
			result = pack.extractToDir(directory);
		}

		if (result!=resultOk){			
			printf(result.string);
		}else{
			printf("\nTotal : %d File(s) unpacked.",pack.totalFiles);						
		}

		pack.finalize();

	}
		

	printf ("\n\npress a key to exit...\n");

	while(!kbhit() );	
	
	return 0;
}
