// CustomPack.cpp: implementation of the CCustomPack class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CustomPack.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCustomPack::CCustomPack(){
	
	CPackFile::CPackFile();

	totalCompress = 0;
	totalUncompress = 0;

	totalFiles = 0;
}

CCustomPack::~CCustomPack(){

	CPackFile::~CPackFile();
}

CResult CCustomPack::saveFileBody(FILE* outStream,TFileInfo* fileInfo){

	char strbuf[255];
	ZeroMemory(strbuf,sizeof(strbuf));
	
	char* p = fileInfo->originalFileName;

	if (strlen(p)>75) {

		p+= (strlen(p)-75)+4;
		printf("...%-72s",p);
	}else{

		printf("%-75s", p);
	}

	
	

	
	CResult result = CPackFile::saveFileBody(outStream,fileInfo);
	
	float percent = (float)(fileInfo->compressSize*100)/fileInfo->uncompressSize;

	printf("%03d%%\n",(unsigned long int)(percent));

	totalCompress += fileInfo->compressSize;
	totalUncompress += fileInfo->uncompressSize;

	totalFiles++;

	return result;
}